#include "main.h"
#include <malloc.h>

_dword_ edi_store;
_dword_ ebp_store;
_ptr_ advman_window;
_ptr_ return_adress;
_ptr_ dlg_item_list;

char buttons_ini[4096];
_ButtonSetup_* buttons[128];
int buttons_count;



int Read_value_from_ini(char** ini)
{
	int n = 0;
	char* digits = "0123456789";
	char* string = *ini;
	BOOL comment = FALSE;
	BOOL is_digit;
	BOOL no_digits = TRUE;
	int i;
	for (i = 0; string[i] != 0; i++)
	{
		is_digit = FALSE;

		if (no_digits)
		{
			if (comment)
			{
				if (string[i] == '\n')
					comment = FALSE;
				continue;
			}
			else if (string[i] == '/')
			{
				if (string[i+1] == '/')
					comment = TRUE;
				continue;
			}
		}

		for (int d = 0; d < 10; d++)
		{
			if (string[i] == digits[d])
			{
				is_digit = TRUE;
				no_digits = FALSE;
				n = n * 10 + d;
				break;
			}
		}
		if (is_digit)
			continue;
		else if (no_digits)
			continue;
		else
			break;
	}
	*ini = string + i;
	if (no_digits)
		return -1;
	return n;
}

int Read_signed_value_from_ini(char** ini)
{
	int n = 0;
	char* digits = "0123456789";
	char* string = *ini;
	BOOL comment = FALSE;
	BOOL is_digit;
	BOOL no_digits = TRUE;
	int m = 1;
	int i;
	for (i = 0; string[i] != 0; i++)
	{
		is_digit = FALSE;

		if (no_digits)
		{
			if (comment)
			{
				if (string[i] == '\n')
					comment = FALSE;
				continue;
			}
			else if (string[i] == '/')
			{
				if (string[i+1] == '/')
					comment = TRUE;
				continue;
			}

			if (string[i] == '-')
			{
				m *= -1;
				continue;
			}
		}

		for (int d = 0; d < 10; d++)
		{
			if (string[i] == digits[d])
			{
				is_digit = TRUE;
				no_digits = FALSE;
				n = n * 10 + d;
				break;
			}
		}
		if (is_digit)
			continue;
		else if (no_digits)
			continue;
		else
			break;
	}
	*ini = string + i;
	if (no_digits)
		return -999999;
	return n*m;
}



char* Read_string_from_ini(char** ini)
{
	char* string = *ini;
	char* result = NULL;
	BOOL comment = FALSE;
	BOOL no_chars = TRUE;
	int i;
	for (i = 0; string[i] != 0; i++)
	{
		if (result == NULL)
		{
			if (comment)
			{
				if (string[i] == '\n')
					comment = FALSE;
				continue;
			}
			else if (string[i] == '/')
			{
				if (string[i+1] == '/')
					comment = TRUE;
				continue;
			}
		}

		if (string[i] == '"')
		{
			if (no_chars)
			{
				no_chars = FALSE;
				string[i] = 0;
				result = string + i + 1;
				continue;
			}
			else
			{
				string[i] = 0;
				*ini = string + i + 1;
				return result;
			}
		}
	}
	return NULL;
}


void Load_Buttons_ini()
{
	DWORD fr;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	char* ini;


	hFile = CreateFile("Buttons.ini", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		MessageBox(0, "Buttons.ini not found!", "Custom Buttons", 0 | MB_ICONHAND);
		return;
	}

	DWORD fsz = GetFileSize(hFile, NULL);
	if (fsz == 0xFFFFFFFF)
	{
		CloseHandle(hFile);
		return;
	}

	ReadFile(hFile, buttons_ini, fsz, &fr, NULL);
	CloseHandle(hFile);
	buttons_ini[fsz] = 0;
	ini = buttons_ini;


	int v;
	buttons_count = Read_value_from_ini(&ini);
	if (buttons_count == -1)
	{
		return;
	}

	for (int i = 0; i < buttons_count; i++)
	{
		_ButtonSetup_* b = new _ButtonSetup_();

		b->parent = Read_value_from_ini(&ini);
		if (b->parent == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		b->ID = Read_value_from_ini(&ini);
		if (b->ID == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		v = Read_signed_value_from_ini(&ini);
		if (v == -999999)
		{
			delete b;
			buttons_count = i;
			break;
		}
		b->x = v;

		v = Read_signed_value_from_ini(&ini);
		if (v == -999999)
		{
			delete b;
			buttons_count = i;
			break;
		}
		b->y = v;

		b->width = Read_value_from_ini(&ini);
		if (b->width == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}
	
		b->height = Read_value_from_ini(&ini);
		if (b->height == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		b->def_name = Read_string_from_ini(&ini);
		if (b->def_name == NULL)
		{
			delete b;
			buttons_count = i;
			break;
		}

		b->def_frame = Read_value_from_ini(&ini);
		if (b->def_frame == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		b->def_frame_press = Read_value_from_ini(&ini);
		if (b->def_frame_press == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		b->hotkey = Read_value_from_ini(&ini);
		if (b->hotkey == -1)
		{
			delete b;
			buttons_count = i;
			break;
		}

		if (b->parent == 0)
		{
			b->colorize = Read_value_from_ini(&ini);
			if (b->colorize == -1)
			{
				delete b;
				buttons_count = i;
				break;
			}
		}

		buttons[i] = b;
	}

}




void DlgItemList_AddNewButton(DWORD dlg_items_list, DWORD id, int x, int y, int width, int height, char* def_name, int def_frame_index, int press_def_frame_index, int hotkey)
{
	_ptr_ btn = homm3_MemAlloc(0x68);
	homm3_DlgButton_Create(btn, x, y, width, height,
		id, def_name, def_frame_index, press_def_frame_index, 0, hotkey, 2);
	DlgItemList_AddItem(dlg_items_list, &btn);
}

void AddAdvmanButtons()
{
	__asm pushad

	for (int i = 0; i < buttons_count; i++)
		if (buttons[i]->parent == 0)
			DlgItemList_AddNewButton(dlg_item_list, 
							buttons[i]->ID,
							buttons[i]->x < 0 ? buttons[i]->x + *(int*)(advman_window + 0x20) : buttons[i]->x,
							buttons[i]->y < 0 ? buttons[i]->y + *(int*)(advman_window + 0x24) : buttons[i]->y,
							buttons[i]->width,
							buttons[i]->height,
							buttons[i]->def_name,
							buttons[i]->def_frame,
							buttons[i]->def_frame_press,
							buttons[i]->hotkey);

	__asm popad
}
__declspec(naked) void hook_Advman_AddButtons()
{
	__asm
	{
		mov eax, 0x5fe2d0
		call eax
		mov dlg_item_list, esi
		mov eax, dword ptr ss:[ebp-0x14]
		mov advman_window, eax
		call AddAdvmanButtons
		push 0x401F9F
		retn
	}
}


void Advman_ColorizeButton(int ID)
{
	__asm
	{
		mov ecx,dword ptr ds:[0x699538]
		mov eax, 0x4ce6e0
		call eax
		mov esi,eax

		mov eax,dword ptr ds:[0x6992b8]
		push ID
		mov ecx,dword ptr ds:[eax+0x44]
		mov eax, 0x5ff5b0
		call eax
		test eax, eax
		je lbl1
		push esi
		mov ecx, eax
		mov eax, 0x4566c0 
		call eax
lbl1:

		push ebp
		mov ebp, ebp_store

		mov al,byte ptr ss:[ebp+8]
		test al,al
		je lbl2
	
		mov eax,dword ptr ss:[ebp+0xc]

		push edi
		mov edi, edi_store
		mov edx,dword ptr ds:[edi]
		push ID
		push ID
		push eax
		mov ecx,edi
		call dword ptr ds:[edx+0x14]
		pop edi

lbl2:
		pop ebp


	}

}

void Advman_ColorizeButtons()
{
	__asm pushad

	for (int i = 0; i < buttons_count; i++)
		if ((buttons[i]->parent == 0) && (buttons[i]->colorize == 1))
			Advman_ColorizeButton(buttons[i]->ID);

	__asm popad

}
__declspec(naked) void hook_Advman_ColorizeButtons()
{
	__asm
	{
		pop eax
		mov return_adress, eax
		mov ebp_store, ebp
		mov edi_store, edi

		mov eax, 0x4CE6E0
		call eax
		
		call Advman_ColorizeButtons

		push return_adress
		retn
	}
}


void Patch()
{

	Patcher::BeginWrite(0x401000, 0x404000);


	Patcher::WriteJmp(0x401F9A, hook_Advman_AddButtons);
	Patcher::WriteCall(0x403f6d, hook_Advman_ColorizeButtons);


	Patcher::EndWrite();

}




BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{


	switch (ul_reason_for_call)
    {
	case DLL_PROCESS_ATTACH:

		Load_Buttons_ini();
		Patch();
        break;
	
	case DLL_PROCESS_DETACH:
		for (int i = 0; i < buttons_count; i++)
			delete buttons[i];
		break;
	
	case DLL_THREAD_ATTACH:
		break;
	
	case DLL_THREAD_DETACH:
		break;
	}

    return TRUE;
}